import random
def array(N1, N2=0,N3=0):   #■配列宣言
    if N2==0: return [0 for i in range(N1)]
    if N3==0: return [[0 for i in range(N2)]
                      for j in range(N1)]
    return[[[0 for i in range(N3)]for j in range(N2)]
           for k in range(N1)]
NUM       = 10    #遺伝子の数
USIZE     = 8    #遺伝子の長さ(ビット数)
Cross     = 0.5   #交叉率
Mutation  = 0.1   #突然変異率
Selection=1-(Cross+Mutation) #選択率
Prob      = array(3) #判定用累積度数分布
Prob[0]   = Selection
Prob[1]   = Prob[0]+Cross
Prob[2]   = 1
Data=array(2,NUM)
def genUnit(USIZE):#■遺伝子生成
    Unit=array(USIZE)
    for i in range(USIZE):
        Unit[i]=1
        if random.random()<0.5:Unit[i]=0
    return Unit
def genData(cID,USIZE):#■複数の遺伝子生成
    global Data; NUM=len(Data[0])
    for i in range(NUM):
        Data[cID][i]=genUnit(USIZE)
FitValue=(0.1,0.2,0.3,0.4,0.5,0.7,0.6,0.5)#適応度
#def elmFit(DT):#■適応度を求める
#    ID=int(DT[7]+DT[6]*2+DT[5]*4)
#    return FitValue[ID]
def elmFit(DT):#■適応度を求める(One Max問題)
    N=len(DT); k=0
    for i in range(len(DT)):
        if DT[i]==1: k+=1

    return k/N
def setFitness(cID,USIZE):#■適応度計算
    global Data; NUM=len(Data[0])
    Fitness=array(NUM); V=USIZE/2
    for i in range(NUM):
        Fitness[i]=elmFit(Data[cID][i])
    return Fitness
def totalFitness(FitNess):#■全適応度合計
    NUM=len(FitNess); T=0
    for i in range(NUM):T+=FitNess[i]
    return T
def cumDisp(Fitness):#■適応度の累積分布生成
    NUM=len(Fitness)
    D=array(NUM);cD=array(NUM)
    T=totalFitness(Fitness)
    for i in range(NUM): D[i]=Fitness[i]/T
    cD[0]=D[0]
    for i in range(1,NUM): cD[i]=cD[i-1]+D[i]
    return cD
def selectUnit(CDisp):#■選択
    R=random.random();NUM=len(CDisp)
    for i in range(NUM):
        if R<CDisp[i]:return i
    return NUM-1
def twoPointProc(A,B,Debug=False):#■2点交差
    global USIZE; AA=array(USIZE);BB=array(USIZE)
    S=int(random.random()*USIZE)
    E=int(random.random()*USIZE)
    while S==E:E=int(random.random()*USIZE)
    if S>E : T=S; S=E; E=T
    if Debug:print("交差範囲",S,E)
    for i in range(USIZE):
        if i>=S and i<=E: AA[i]=B[i];BB[i]=A[i]
        else:             AA[i]=A[i];BB[i]=B[i]
    return [AA,BB]
def uniformCross(A,B,Debug=False):#■一様交差
    global USIZE; AA=array(USIZE);BB=array(USIZE)
    for i in range(USIZE):
        if A[i]==B[i] or random.random()<0.5:
            AA[i]=A[i];BB[i]=B[i]
        else:AA[i]=B[i];BB[i]=A[i]
    return [AA,BB]
def crossProc(A,B,method=True,Debug=False):#■交叉処理選択
    if method:return twoPointProc(A,B,Debug)
    else:return uniformCross(A,B,Debug)
def mutationProc(A,Debug=False):#■突然変異
    global USIZE;AA=array(USIZE)
    S=int(random.random()*USIZE)
    if Debug:print("突然変異ビット",S)
    for i in range(USIZE):
        if   i!=S   : AA[i]=A[i]
        elif A[i]==1: AA[i]=0
        else        : AA[i]=1
    return AA
def printBit(k,DT,FT):#■ビット形式の生成
    S="%4d:"%k
    for i in range(len(DT)):
        if i%4==0: S+=" "
        S+="%1d" % DT[i]
    print(S+FT)
def printDT(cID):#■データ表示
    global Data,USIZE;
    Fitness=setFitness(cID,USIZE);NUM=len(Data[cID])
    for i in range(0,NUM):
        printBit(i,Data[cID][i],"%8.4f" % Fitness[i])
def printResult(cID):#■結果の表示
    global Data,USIZE;NUM=len(Data[cID])
    Fitness=setFitness(cID,USIZE);MX=Fitness[0]
    for i in range(1,NUM):
        if Fitness[i]>MX: MX=Fitness[i]
    for i in range(0,NUM):
        if abs(Fitness[i]-MX)<0.001:
            printBit(i,Data[cID][i],"")
def GA(NumG,Debug=False):#■GAメイン
    global Data
    cID=0;nID=1-cID; genData(nID,USIZE)
    NUM=len(Data[0])
    if Debug:print(Data)
    print("\n初期値")
    printDT(nID)
    print("\n適応度の高い遺伝子")
    printResult(nID)
    for i in range(NumG):#ループ回数だけ繰返し
        cID=nID;nID=1-cID;
        Fitness=setFitness(cID,USIZE)#適応度を求める
        if Debug:print(Fitness)
        CDisp=cumDisp(Fitness)#適応度の累積度数
        if Debug:print("CDisp",CDisp)
        k=0
        while k<NUM:#
            if Debug:print()
            R=random.random()
            S1=selectUnit(CDisp)
            if R<Prob[0]:#選択
                Data[nID][k]=Data[cID][S1]
                if Debug:print("選択              %4d"%k,
                               Data[nID][k])
                k+=1
            elif R<Prob[1]:
                if k==NUM-1:#最後なら「選択」とみなす
                    Data[nID][k]=Data[cID][S1]
                    if Debug:print("交差(選択)        %4d"%k,
                                   Data[nID][k])
                    k+=1
                else:#交差(組み換え)
                    S2=selectUnit(CDisp)
                    while S1==S2:S2=selectUnit(CDisp)
                    if Debug:
                        print("交差(通常)元データ   1",Data[cID][S1])
                        print("交差(通常)元データ   2",Data[cID][S2])
                    #第3引数:Trueのとき2点交差，Falseのとき一様交差
                    AB=crossProc(Data[cID][S1],Data[cID][S2],False)
                    Data[nID][k]=AB[0]
                    if Debug:print("交差結果 1        %4d"%k,AB[0])
                    k+=1
                    Data[nID][k]=AB[1]
                    if Debug:print("交差結果 2        %4d"%k,AB[1])
                    k+=1
            else:#突然変異
                if Debug:print("突然変異元データ      ",Data[cID][S1])
                Data[nID][k]=mutationProc(Data[cID][S1])
                if Debug:print("突然変異          %4d"%k,Data[nID][k])
                k+=1
    cID=nID
    print("\n結果")
    printDT(cID)
    print("\n適応度の高い遺伝子")
    printResult(cID)

GA(5000)
